/* Programa BAGGING que calcula el porcentaje de error, dicho programa saca muestras con    *
 *reemplazamiento para obetener los estimados  y luego clasificar para obtener los errores  */

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#define CTE 2.506631   /*CTE=sqrt(2.0*PI)*/
#define WORK 0
#define DONE 1
#define RESULT 2
//#include <mpi.h> 



/* funcion que sirve para imprimir matrices de tipo double en la pantalla, se ingresar la matriz con sus respectivas filas y columnas*/
void print(double **X,int n,int m){
       int i,j;
        for(i=0;i<n;i++){
                for(j=0;j<m;j++)
                      printf("%e\t",X[i][j]);
                 printf("\n");
           }

       }
       
/* funcion que sirve para imprimir matrices de tipo entero  en la pantalla, se ingresar la matriz con sus respectivas filas y columnas*/
void print2(int  **X,int n,int m){
       int i,j;
        for(i=0;i<n;i++){
                for(j=0;j<m;j++)
                      printf("%d\t",X[i][j]);
                 printf("\n");
           }

       }


/*funcion que dado una matriz X, obtiene la n-esima division de X,  se debe ingresar un entero *
 * minimo, el # de filas de la division, y el # de columnas de la matriz                       */ 
 
 double ** test(double **data,double **X,double *w,int min,int r,int n_trai,int p){
          double **temp;
          int i;
          for(i=0;i<n_trai;i++){
	    w[i]=1.0/(double)n_trai;
	      if(i<min)
		data[i]=X[i];
	      else
		data[i]=X[i+r];
	  }

          temp=calloc(r,sizeof(double *)); 
          for(i=0;i<r;i++)
              temp[i]= X[i+min]; 
          return temp;
          }

/*funcion que dado una matriz X, obtiene una muestra con reemplazamiento de las filas de X distintas de *
 * de las filas  que se uso para test, se debe ingresar un entero  minimo, maximo, # de filas de la     *
 * division  y el # de columnas de la matriz                       				        */ 
 

double ** training2(double **X,int min,int max,int n){
          double **temp;
          int i,j;
          temp=calloc(n,sizeof(double *));   //se asigna memoria dinamica para la matriz de salida
          for(i=0;i<min;i++)
                temp[i]= X[i];               //se asigna al vector de salida las filas de X desede 0 hasta un minimo
          for(i=min;i<n-(max-min);i++)
                temp[i]= X[i+max-min];      //se asigna al vector de salida las filas de X desde un maximo hasta N */
           return temp;
         }


double ** training(double **X,int n_trai,int m,int p,double *tab){
          double **temp;
	  double *class=NULL;
	  double min=0.0;
	  long r;
          int i;
	class=calloc(m+1,sizeof(double));
	  for(i=0;i<m+1;i++)
	    class[i]=0.0;
          temp=calloc(n_trai,sizeof(double *));
          for(i=0;i<n_trai;i++){
	    r=rand();
	    temp[i]= X[r%n_trai];
	    class[(int)temp[i][p-1]]+=1.0;

	  }  
	  min=class[1];
	  for(i=2;i<m+1;i++){
	    if(class[i]<=min)
	      min=class[i];
	  }
   	   *tab=min;
           return temp;				
         }


double **trai_weight(double **data,double *w,int min,int max,int n_trai){
  int i,j,p,r,num=n_trai*10;
  int *indice=NULL;
  double s=0.0,t=0.0;
  double *prob_acum=NULL;
  double **temp;      
  indice = calloc(n_trai,sizeof(int));
  temp=calloc(n_trai,sizeof(double *));
  prob_acum = calloc(n_trai,sizeof(double));
   for(i=0;i<n_trai;i++)
     s=s+w[i];
   for(i=0;i<n_trai;i++){
     w[i]=w[i]/s;
     t+=w[i];
     prob_acum[i]=t;
   }


   /*
   for(i=0;i<n_trai;i++){
     r=rand();
     temp[i]= data[r%n_trai];
    // class[(int)temp[i][p-1]]+=1.0;
   }  
   */

      
   for(i=0;i<n_trai;i++){
     p=rand()%num;
     for(j=0;j<n_trai;j++){ 
       if(((double)p/(double)num)<prob_acum[j]){
	 indice[i]=j;
	 break;
       }
     }
     temp[i]=data[indice[i]];
   }
   

 /*
   for(i=0;i<n_trai;i++){
     r=rand();
     temp[i]= data[r%n_trai];
    // class[(int)temp[i][p-1]]+=1.0;
   }  
  
     for(i=0;i<n_trai;i++)
        indice[i]=i;
	*/

   return temp;
}
int * randperm(int n ){
       int i,j,min;
       int * a=NULL;
       int * indice=NULL;
       indice=(int *)calloc(n,sizeof(int));
       a=(int *)calloc(n,sizeof(int));   
       srand(time(NULL)); 
       for(i=0;i<n;i++)
           a[i]=rand()%n; 
       for ( i = 0; i < n;i++ ){
           min=i;
           for (j = 0; j < n; j++ )
                if ( a[j] < a[min] ) {
                    min=j;
                }
           a[min]=n;
           indice[i]=min; 
       }
       return indice;
       }

/*funcion que calcula el kernel gaussiano*/
double kernel(double x){
       return 1.0/(exp((x*x)/2.0))*CTE;        /*CTE =sqrt(2.0*PI)*/
       }

/*funcion que calcula el vector  del ancho de banda para una clase X, se debe ingresar el # de filas de la clase asi como  el # de columanas*/

double * banda(double **X, int n,int p){
       double s,d, Xmean,*h=NULL;
       int i,v;

       h=calloc(n,sizeof(double)); 
       for(v=0;v<p ;v++){
            Xmean=0;
            d=0;
            s=0;
            for(i=0;i<n;i++){
                 s+=X[i][v];
            }
            Xmean =s/n;       
            for(i=0;i<n;i++){
                d+=(X[i][v]-Xmean)*(X[i][v]-Xmean);
            }
            d=sqrt(d/(n-1));    
                                
            h[v]=d*(pow(4.0,1.0/(double)(p+4))/pow((double)((p+2)*n),1.0/(double)(p+4)));  

       }
       return h;
       }




double * fpiloto(double **x,double *h,double **X,double *g, int p,int m_elem,int n_cross,int N){
       int v,j,i;
       double s=0.0,t,k,H=1.0,alpha=-0.5;
       double *f=NULL;
       double pro=(double)m_elem/(double)(N-n_cross);//se calcula la proporcion para el estimado de una clase cualquiera
       double geometrica(double *,int);

       f=calloc(m_elem,sizeof(double));//se asigna memoria dinamica para el vector de salida
       for(v=0;v<p;v++)
                   H*=h[v];   //se calcula la productoria de los elemantos del ancho de  banda
        H=H*(double)m_elem;
       // H=exp(H);
       for (i=0;i<m_elem;i++){

              s=0.0;                   
              for(j=0;j<m_elem ;j++){
                 k=1.0;
                 for(v=0;v<p;v++){
                     t=kernel((x[i][v]-X[j][v])/h[v]);
                     k=k*t;
                 }
                 s=s+k;
               }
     
	       f[i]=(s/H);
       }
       *g=geometrica(f,m_elem);
       for(i=0;i<m_elem;i++)
	   f[i]= pow(f[i]/(*g),alpha);
       return f;
       }

double * estimado(double **x,double *h,double **X,int n_cross, int p,int m_elem,int N){
       int v,j,i;
       double s=0.0,t,k,g,H=0.0,alpha =-0.5,lamda;
       double *fhat=NULL;
       double *f=NULL;
       double pro=(double)m_elem/(double)(N-n_cross);//se calcula la proporcion para el estimado de una clase cualquiera
       double geometrica(double *,int);

       fhat = calloc(m_elem,sizeof(double)); 
       f=calloc(n_cross,sizeof(double));//se asigna memoria dinamica para el vector de salida
       for(v=0;v<p;v++)
                   H+=log(h[v]);   //se calcula la productoria de los elementos del ancho de  banda
       H=exp(H)*(double)m_elem;

       fhat = fpiloto(X,h,X,&g,p,m_elem,n_cross,N);
             
       for (i=0;i<n_cross;i++){
              s=0.0;
              for(j=0;j<m_elem ;j++){
                 k=1.0;
                 for(v=0;v<p;v++){
		    t=kernel((x[i][v]-X[j][v])/(fhat[j]*h[v]));
                     k=k*t;
                 }
                 s=s+(k/pow(fhat[j],p-1)); 
               }
	       f[i]=pro*(s/H);


       }
 
    return f;
    }


double geometrica(double *f,int n_trai){
     int i;
     double g=0.0;
     for(i=0;i<n_trai;i++){
       //g*=f[i];
       g=g+log(f[i]);
     }
     // g=pow(g,1.0/(double)n_trai);
     g=exp(g/(double)n_trai);
     return g;
   }


/* funcion que calcula los errores dado una matriz M de dimension(n_boos X n_test), se debe ingresar el vector de indices de la muestra original(k)  *
 * el # de columnas de M(n_test), el # de filas de M(n_boos), el # de clases(m) y un entero minimo(min) para relizar las comparaciones con el vector k */

 int error(int **M,int * k_indices, double *beta,int n_test,int n_boos,int m,int min ){
       int i,j,e=0,k;
       double max;
       double *clase=NULL;
       clase=calloc(m+1,sizeof(double)); 

       for(j=0;j<n_test;j++){
             for(i=0;i<m+1;i++) clase[i]=0.0;  
             for(i=0;i<n_boos;i++) {clase[M[i][j]]+=log(1.0/beta[i]);}
             max=0.0;
             k=0;   
	     //            for(i=0;i<m+1;i++) 
             for(i=0;i<m+1;i++){
                 if(clase[i]>max){   
                      max=clase[i];
                      k=i;      
                 }
                      
             } 
             if(k_indices[j+min]!=k) 
                 e++;
       }
       return e;
       }





/*funcion que calcula el vector de maximos dado una matriz f de estimados, se debe ingresar el # de filas de f (m), el # de columnas(n)*/
int  *maximos(double **f,int n,int m ){
      int i,j,k;
      int *max=NULL;
      double maximo;
      max = calloc(n,sizeof(int)); 
      for(j=0;j<n;j++){
             maximo=0;
             for(i=0;i<m;i++){
                   if(f[i][j]>=maximo){
                        maximo=f[i][j];
                        k=i+1;
                    }
             }
             max[j]=k;     
       }
       return max;
       }


double **estimated(double ** x, double ** X,int n_trai, int p,int m,int r,int N){
       double **f;
       double ** temp;
       double *h=NULL;
       int i,j,cont;

       f=calloc(m,sizeof(double *)); //se asigna memoria dinamica para la matriz de estimados
       temp=calloc(n_trai,sizeof(double *)); //se asigna memoria dinamica para la matriz de clases
       h=calloc(p,sizeof(double));   //se asigna memoria dinamica para el vector del ancho de banda
       for(j=0;j<m;j++){
            cont=0;
            for(i=0;i<n_trai;i++)
                    if(X[i][p-1]==(double)(j+1)){
                       temp[cont++]= X[i];
                    }

            h=banda(temp,cont,p-1);       
            f[j] = estimado(x,h,temp,r,p-1,cont,N);
      }
      return f;
}



double max_error(double **ftrai,double **f,double *w,int *k_indices,int *max,int *k,int r,int min,int m,int n_trai ){
      int i,j,cont;
      double e=0.0,maximo;
      
      for(j=0;j<r;j++){
             maximo=0.0; 
             for(i=0;i<m;i++){
                   if(f[i][j]>=maximo){
                        maximo=f[i][j];
                        cont=i+1;

                    }
             }
	     max[j]=cont;
       }
     


      for(j=0;j<n_trai;j++){
             maximo=0.0; 
	
             for(i=0;i<m;i++){
                  if(ftrai[i][j]>=maximo){
                           maximo=ftrai[i][j];
                           cont=i+1;
                   }
             }

                if(j<min){
	              if(k_indices[j]!=cont){
	                   e+=w[j];
		           k[j]=0;

	               }
  	               else
	                   k[j]=1;
                 }
                else{	   
	             if(k_indices[j+r]!=cont){
                         e+=w[j];
	                 k[j]=0;

	              }
	              else
	                 k[j]=1;    
		}
       }

      return e;
}


void normalizador(double *w,int n_trai){
  int j;
  double s=0.0;
      for(j=0;j<n_trai;j++){
	s+=w[j];
      }

      for(j=0;j<n_trai;j++){
	w[j]=w[j]/(double)s;

      }
}

int *max_estimado(double **data,double ** x, double ** X,int *k_indices,double *w,int n, int p,int m,int r,int min,double *eb){
       
       int i,j,tol=25,cont,n_trai= n-r,max=min+r,critico=3;
       int *maximos=NULL;
       int *k=NULL;
       double maximo,e=0.0,tabulate; 
       double **f;
       double **ftrai;
 
       k=calloc(n_trai,sizeof(int));
       f=calloc(m,sizeof(double *));   
       ftrai=calloc(m,sizeof(double *));   
       maximos = calloc(r,sizeof(int));

       
       f=estimated( x,X,n_trai,p,m,r,n);//paralelo
       //print(f,m,r);
       ftrai=estimated(data,X,n_trai,p,m,n_trai,n);//paralelo 
       //print(ftrai,m,n_trai);
       e= max_error(ftrai,f,w,k_indices,maximos,k,r,min, m,n_trai );
     
       if((e<0.5)&&(e!=0.0)){     
	for(j=0;j<n_trai;j++){
	  if(k[j]==1)
	     w[j]=(w[j])/(2*e);
	  else
	    w[j]=(w[j])/(2.0*(1.0-e));
	}
      }
      else{ 
	  for(j=0;j<tol;j++){
	    tabulate=0.0;
	    while(tabulate<=(double)critico){
	         X=training(data,n_trai,m,p,&tabulate);
	    }
             f=estimated( x,X,n_trai,p,m,r,n); 
	     ftrai=estimated(data,X,n_trai,p,m,n_trai,n); 
	     for(i=0;i<n_trai;i++)
	         w[i]=1.0/(double)n_trai;
             e= max_error(ftrai,f,w,k_indices,maximos,k,r,min, m ,n_trai);
	       if((e<0.5)&&(e!=0)){
		
		 break;
	        }
	  }

     	  for(j=0;j<n_trai;j++){
	       if(k[j]==1)
	           w[j]=(w[j]*(double)n_trai)/(2*e);
	       else
	            w[j]=(w[j]*(double)n_trai)/(2*((double)n_trai-e));
	   }
        }

      *eb=e;
      return maximos;
      
}

/*funcion que calcula los errore al clasificar, se debe ingresar el vector de los datos originales(x), el numero de filas(n), el numero de *
 * muestras boostrapeadas (n_boos), el # de clases(m) y el # de columnas (p)								   */

int boosting(double * x,int n,int n_boos,int m,int p){
    int i,j=0,r=n/10,e=0,err=0,b;
    int *indice=NULL;
    int **M;
    int *k=NULL;
    double eb,tabulate;
    double *beta;
    double *w=NULL;
    double **f;
    double **tes;
    double **X;
    double **trai;
    double **data;
    
    k=calloc(n,sizeof(int));          
    indice=(int *)calloc(n,sizeof(int));
    M=calloc(n_boos,sizeof(int *));   
    beta=calloc(n_boos,sizeof(double));
    w=calloc(n,sizeof(double));
    X=calloc(n,sizeof(double *));     
    tes=calloc(n,sizeof(double *));   
    trai=calloc(n-r+1,sizeof(double *));  
    data=calloc(n-r+1,sizeof(double *));      
   
    indice=randperm(n);  
    for(i=0;i<n;i++){
       X[i]=x+indice[i]*p; 
          k[i]=X[i][p-1]; 
	  //          w[i]=1.0;///(double)n;                 
    }



    if(n%10==0){	
          for(i=0;i<10;i++){
             j=j+r;
             tes=test(data,X,w,j-r,r,n-r,p);  
             for(b=0;b<n_boos;b++){
                  trai=trai_weight(data,w,j-r,j,n-r);  
                  M[b]=max_estimado(data,tes,trai,k,w,n,p,m,r,j-r,&eb);
		  beta[b]=eb/(1.0-eb);        
	     }

	     e=error(M,k,beta,r,n_boos,m,j-r);
	     err+=e;	
	 
          }
     }
     else {			
           for(i=0;i<n%10;i++){
              j=j+r+1;
              tes=test(data,X,w,j-r-1,r+1,n-r-1,p); 
              for(b=0;b<n_boos;b++){           
		 trai=trai_weight(data,w,j-r-1,j,n-r-1);
                  M[b]=max_estimado(data,tes,trai,k,w,n,p,m,r+1,j-(r+1),&eb);
		  beta[b]=eb/(1.0-eb);
             }
             e=error(M,k,beta,r+1,n_boos,m,j-(r+1));   
             err+=e;                              
	                        
           }
           for(i=n%10;i<10;i++){
               j=j+r;
               tes=test(data,X,w,j-r,r,n-r,p);
               for(b=0;b<n_boos;b++){
	       trai=trai_weight(data,w,j-r,j,n-r);
	       M[b]=max_estimado(data,tes,trai,k,w,n,p,m,r,j-r,&eb);
	       beta[b]=eb/(1.0-eb);
               } 
               e=error(M,k,beta,r,n_boos,m,j-r);     
               err+=e;				
           }
     }
     return err;
     }

/* funcion main, se debe ingresar en la linea de comandos lo siguiente:  *
 * argv [1] la matriz original; argv [2] el numero de filas, argv [3]   *
 * argv [3] el numero de columnas; argv [4] el numero de clases y      *
 * argv [5] el numero de muestras boostrapeadas                       */

int main(int argc, char * argv[]){

    FILE *in;      
    int n_boos,promedio;
    int n,m,p,rank,size;
    int r,t,b,i,j=0,s,err=0,e;
    int *indice=NULL;
    clock_t  now, later;
    double *x=NULL;
    double tiempo;
    double **f;
    double **tes;
    double **X;
    double **trai;
    int **M;
    int *max;
    int *k=NULL;
    long passed;
    now = clock();
    srand(time(0x0));   

 if(argc!=7){
       fprintf(stderr,"Uso de %s\n  nombre_del_archivo #_de_filas  #_de_columnas #_de_clases #_de_muestras_boostrapeadas # promedio\n",argv[0]);
       exit(1);
    }

    srand(time(0x0));   


    n=atoi(argv[2]);    
    p=atoi(argv[3]);    
    m=atoi(argv[4]);    
    n_boos=atoi(argv[5]);    
    promedio=atoi(argv[6]);    

    indice=calloc(n,sizeof(int));
    k=calloc(n,sizeof(int));
    x=calloc(n*p,sizeof(double));    
    tes=calloc(n,sizeof(double *)); 
    trai=calloc(n,sizeof(double *)); 
    f=calloc(m,sizeof(double *)); 
    X=calloc(n,sizeof(double *)); 
    M=calloc(n_boos,sizeof(int *));   
    max = (int *)calloc(n/10+1,sizeof(int));

   
    in=fopen(argv[1],"r");        

       
 if(in==NULL){                 
         printf("problemas con el archivo de salida");
         exit(1);
    }
    

    while (!feof(in)){       
             fscanf(in,"%lf",&x[j]); 
             j++;
      }
   fclose(in); 

   for(i=0;i<promedio;i++){
       e=boosting(x,n,n_boos,m,p);   
       err+=e;
     }
   later = clock();
   passed =  later - now;
   
   printf("\nPROGRAMA %s DATA %s ERRORES %f TIEMPO %.4f \n",argv[0],argv[1],(double)err/(double)(n*promedio),(float)passed/(float)(1000000*promedio));
   return 0;

}
