/* Programa BAGGING que calcula el porcentaje de error, dicho programa saca muestras con    *
 *reemplazamiento para obetener los estimados  y luego clasificar para obtener los errores  */

#include <mpi.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#define CTE 2.506631   /*CTE=sqrt(2.0*PI)*/
#define WORK 0
#define DONE 1
#define RESULT 2
  
double ** test(double **X,int min,int n,int p){
          double **temp;
          int i;
          temp=calloc(n,sizeof(double *)); 
          for(i=0;i<n;i++)
              temp[i]= X[i+min]; 
          return temp;
          }
 
double ** training(double **X,int min,int max,int n,int p,int m){
   int i,n_trai=n-(max-min),r;
   double tabulate=0.0,critico=5.0;       
   double *class=NULL;
   double **temp;
   
   temp=calloc(n,sizeof(double *));
   class=calloc(m+1,sizeof(double));
   for(i=0;i<m+1;i++)
     class[i]=0.0;
   
   tabulate=0.0;
   
   while(tabulate<=critico){  
     for(i=0;i<n_trai;i++){
       r=rand()%n_trai;
       if(r<min)
	 temp[i]= X[r];
       else
	 temp[i]= X[r+(max-min)];
       class[(int)temp[i][p-1]]+=1.0;  
     }
     tabulate=class[1];
     for(i=2;i<m+1;i++){
       if(class[i]<=tabulate)
	 tabulate=class[i];
     }
   }
   
   return temp;	   
			
}

int * randperm(int n ){
       int i,j,min;
       int * a=NULL;
       int * indice=NULL;
       indice=(int *)calloc(n,sizeof(int));
       a=(int *)calloc(n,sizeof(int));   
       srand(time(NULL)); 
       for(i=0;i<n;i++)
           a[i]=rand()%n; 
       for ( i = 0; i < n;i++ ){
           min=i;
           for (j = 0; j < n; j++ )
                if ( a[j] < a[min] ) {
                    min=j;
                }
           a[min]=n;
           indice[i]=min; 
       }
       return indice;
       }

double kernel(double x){
       return 1.0/(exp((x*x)/2.0))*CTE;        /*CTE =sqrt(2.0*PI)*/
       }

/*funcion que calcula el vector  del ancho de banda para una clase X, se debe ingresar el # de filas de la clase asi como  el # de columanas*/


double * banda(double **trai, int **clases,int n_trai,int j,int p){
       double s,d, Xmean;
       double *h=NULL;
       int i,v;
       h=calloc(p,sizeof(double));          

       for(v=0;v<p ;v++){
	 Xmean=0;
	 d=0;
	 s=0;
	 for(i=0;i<n_trai;i++){
	   s+=trai[clases[j][i]][v];
	 }
	 Xmean =s/n_trai;                   
	 for(i=0;i<n_trai;i++){
	   d+=(trai[clases[j][i]][v]-Xmean)*(trai[clases[j][i]][v]-Xmean);
	 }
	 d=sqrt(d/(n_trai-1));                          //para cada columna se calcula la desviacion estandar
	 
	 h[v]=d*(pow(4.0,1.0/(double)(p+4))/pow((double)((p+2)*n_trai),1.0/(double)(p+4)));
       }
       return h;
       }




double * fpiloto(double **X,double *h,int **clases,double *g,int n_trai,int c, int p,int N){
       int v,j,i;
       double s=0.0,t,k,H=1.0,alpha=-0.5;
       double *f=NULL;
       double geometrica(double *,int);
       f=calloc(n_trai,sizeof(double));
       for(v=0;v<p;v++)
                   H*=h[v];
        H=H*(double)n_trai;
       for (i=0;i<n_trai;i++){
              s=0.0;                   
              for(j=0;j<n_trai ;j++){
                 k=1.0;
                 for(v=0;v<p;v++){
                     t=kernel((X[clases[c][i]][v]-X[clases[c][j]][v])/h[v]);
                     k=k*t;
                 }
                 s=s+k;
               }
	       f[i]=(s/H);
       }
       *g=geometrica(f,n_trai);
       for(i=0;i<n_trai;i++)
	   f[i]= pow(f[i]/(*g),alpha);
       return f;
       }

double * kernel_adaptativo(double **x,double *h,double **trai, int **clases,int n_trai,int c,int n_cross, int p,int N){
       int v,j,i;
       double s=0.0,t,k,g,H=0.0;
       double *fhat=NULL;
       double *f=NULL;
       double pro=(double)n_trai/(double)(N-n_cross);
       double geometrica(double *,int);

       fhat = calloc(n_trai,sizeof(double)); 
       f=calloc(n_cross,sizeof(double));
       for(v=0;v<p;v++)
                   H+=log(h[v]);   
       H=exp(H)*(double)n_trai;
       fhat = fpiloto(trai,h,clases,&g,n_trai,c,p,N);
       for (i=0;i<n_cross;i++){
              s=0.0;
              for(j=0;j<n_trai ;j++){
                 k=1.0;
                 for(v=0;v<p;v++){
		    t=kernel((x[i][v]-trai[clases[c][j]][v])/(fhat[j]*h[v]));
                     k=k*t;
                 }
                 s=s+(k/pow(fhat[j],p-1)); 
               }
	       f[i]=pro*(s/H);
       }
    return f;
    }


double geometrica(double *f,int n_trai){
     int i;
     double g=0.0;
     for(i=0;i<n_trai;i++){
       g=g+log(f[i]);
     }
     g=exp(g/(double)n_trai);
     return g;
   }




int *max_estimado_kernel_adaptativo(double ** x, double ** X, int n,int p,int m,int r){
  int i,j,k,ntrai= n-r;
  int *max=NULL;
  int *n_trai=NULL;       
  int **clases;
  double maximo;
  double **f;
  double *h=NULL;
  
  n_trai=calloc(m+1,sizeof(int));
  clases =calloc(m+1,sizeof(int *));
  f=calloc(m,sizeof(double *)); 
  h=calloc(p,sizeof(double));   
  for(j=0;j<=m;j++){
    n_trai[j]=0; 
    clases[j]=calloc(n,sizeof(int));   
  }  
  for(i=0;i<ntrai;i++){
    clases[(int)X[i][p-1]][n_trai[(int)X[i][p-1]]++]=i;
  }
  for(j=0;j<m;j++){
    h=banda(X,clases,n_trai[j+1],j+1,p-1); 
    f[j] = kernel_adaptativo(x,h,X,clases,n_trai[j+1],j+1,r,p-1,n);
  }
  max = calloc(r,sizeof(int)); 
  for(j=0;j<r;j++){
    maximo=0;
    for(i=0;i<m;i++){
      if(f[i][j]>=maximo){
	maximo=f[i][j];
	k=i+1;
      }
    }
    max[j]=k;     
  }
  return max;
}


int error_votacion_bagging(int **M,int * k_indices ,int n_test,int n_boos,int m,int min ){
  int i,j,e=0,k,max;
  int *clase=NULL;
  clase=calloc(m+1,sizeof(int)); 
  for(j=0;j<n_test;j++){
    for(i=0;i<m+1;i++) clase[i]=0;  
    for(i=0;i<n_boos;i++) clase[M[i][j]]++; 
    max=0;
    k=0;            
    for(i=0;i<m+1;i++){
      if(clase[i]>max){   
	max=clase[i];
	k=i;      
      }
    } 
    if(k_indices[j+min]!=k) 
      e++;
  }
  return e;
}


int bootstrapping(double * x,int n,int n_boos,int m,int p){
    int i,j,r=n/10,e=0,err=0,b;
    int *indice=NULL;
    double **tes;
    double **X;
    double **trai;
    int **M;
    int *k=NULL;
    M=calloc(n_boos,sizeof(int *));   
    X=calloc(n,sizeof(double *));     
    tes=calloc(n,sizeof(double *));   
    trai=calloc(n,sizeof(double *));  
    k=calloc(n,sizeof(int));          
    indice=(int *)calloc(n,sizeof(int));
    
    indice=randperm(n);  
    for(i=0;i<n;i++){
          X[i]=x+indice[i]*p; 
          k[i]=X[i][p-1]; 
                    
    }
    j=0;
    if(n%10==0){	
          for(i=0;i<10;i++){
             j=j+r;
             tes=test(X,j-r,r,p);    
             for(b=0;b<n_boos;b++){
	       trai=training(X,j-r,j,n,p,m);  
	       M[b]=max_estimado_kernel_adaptativo(tes,trai,n,p,m,r);        
             }
	
             e=error_votacion_bagging(M,k,r,n_boos,m,j-r);      
             err+=e;			       

          }

     }
     else {			
           for(i=0;i<n%10;i++){
              j=j+r+1;
              tes=test(X,j-r-1,r+1,p);                 
              for(b=0;b<n_boos;b++){
                  trai=training(X,j-r-1,j,n,p,m);        

		  M[b]=max_estimado_kernel_adaptativo(tes,trai,n,p,m,r+1);        
             }
             e=error_votacion_bagging(M,k,r+1,n_boos,m,j-(r+1));   
             err+=e;                              
                       
           }
           for(i=n%10;i<10;i++){
               j=j+r;
               tes=test(X,j-r,r,p);               
               for(b=0;b<n_boos;b++){
                  trai=training(X,j-r,j,n,p,m);
		  M[b]=max_estimado_kernel_adaptativo(tes,trai,n,p,m,r);           
               } 
               e=error_votacion_bagging(M,k,r,n_boos,m,j-r);     
               err+=e;				
           }
     }
     return err;
     }

int main(int argc, char * argv[]){
  int rank,size;
  MPI_Status status;
  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  
  if(rank==0){
    FILE *in;      
    int  n,m,p, n_boos, r,t,b,i,j=0,s,err=0,e,promedio;
    int parametro[5];
    int *indice=NULL;
    double tiempo;
    double *x;
    double **f;
    double **tes;
    double **X;
    double **trai;
    int **M;
    int *max;
    int *k=NULL;
    if(argc!=7){
       fprintf(stderr,"Uso de %s\n  nombre_del_archivo #_de_filas  #_de_columnas #_de_clases #_de_muestras_boostrapeadas #promedio \n",argv[0]);
       exit(1);
    }
    tiempo= MPI_Wtime();
    srand(time(0x0));   
    n=atoi(argv[2]);    
    p=atoi(argv[3]);    
    m=atoi(argv[4]);    
    n_boos=atoi(argv[5]);    
    promedio=atoi(argv[6]);    
    parametro[0]=n; 
    parametro[1]=p;
    parametro[2]=m;
    parametro[3]=n_boos;
    parametro[4]=promedio;
    MPI_Bcast(parametro,5,MPI_INT,0,MPI_COMM_WORLD);    
    indice=calloc(n,sizeof(int));
    k=calloc(n,sizeof(int));
    x=calloc(n*p,sizeof(double));    
    tes=calloc(n,sizeof(double *)); 
    trai=calloc(n,sizeof(double *)); 
    f=calloc(m,sizeof(double *)); 
    X=calloc(n,sizeof(double *)); 
    M=calloc(n_boos,sizeof(int *));   
    max = (int *)calloc(n/10+1,sizeof(int));
    in=fopen(argv[1],"r");        
    if(in==NULL){                 
      printf("problemas con el archivo de salida");
      exit(1);
    }    
    while (!feof(in)){       
      fscanf(in,"%lf",&x[j]); 
      j++;
    }
    fclose(in); 
    if(size==1){
      for(i=0;i<promedio;i++){
       e=bootstrapping(x,n,n_boos,m,p);   
       err+=e;
      }
      tiempo=MPI_Wtime()-tiempo;
      printf("\nPROGRAMA %s DATA %s PROCRS  %d  N_BOOST %d ERRORES %lf tiempo paralelo es %.3lf \n: ",argv[0],argv[1],size,n_boos,(double)err/(double)(n*promedio),(double)tiempo/(double)promedio);
      MPI_Finalize(); 
      return 0;
    }

   else{
     err=0;
     MPI_Bcast(x,n*p,MPI_DOUBLE,0,MPI_COMM_WORLD);
     r=n/10;    
     for(t=0;t<promedio;t++){
       indice=randperm(n); 
       MPI_Bcast(indice,n,MPI_INT,0,MPI_COMM_WORLD);
       for(i=0;i<n;i++){
	 X[i]=x+indice[i]*p; 
	 k[i]=X[i][p-1];   
       }
       j=0;
       if(n%10==0){	
	 for(s=0;s<10;s++){
	   b=0;
	   j=j+r;
	   for(i=0;i<size-1;i++) {
	     MPI_Ssend(&t,0,MPI_INT,i+1,WORK,MPI_COMM_WORLD);
	   }
	   for(i=size-1;i<n_boos;i++)  {
	     MPI_Recv(max,r,MPI_INT,MPI_ANY_SOURCE,RESULT,MPI_COMM_WORLD,&status);
	     M[b++]= max ;
	     MPI_Ssend(&t,0,MPI_INT,status.MPI_SOURCE,WORK,MPI_COMM_WORLD);    
	   }   
	   for(i=0;i<size-1;i++) {
	     MPI_Recv(max,r,MPI_INT,MPI_ANY_SOURCE,RESULT,MPI_COMM_WORLD,&status);
	     M[b++]=max;
	     MPI_Ssend(&t,0,MPI_INT,status.MPI_SOURCE,DONE,MPI_COMM_WORLD);
	   }
	   e=error_votacion_bagging(M,k,r,n_boos,m,j-r);      
	   err+=e;			       
	 }
       }
       else {			
	 for(s=0;s<n%10;s++){
	   j=j+r+1;
	   b=0;
	   for(i=0;i<size-1;i++) {
	     MPI_Ssend(&t,0,MPI_INT,i+1,WORK,MPI_COMM_WORLD);
	   }
	   for(i=size-1;i<n_boos;i++)  {
	     MPI_Recv(max,r+1,MPI_INT,MPI_ANY_SOURCE,RESULT,MPI_COMM_WORLD,&status);
	     M[b++]= max ;
	     MPI_Ssend(&t,0,MPI_INT,status.MPI_SOURCE,WORK,MPI_COMM_WORLD);    
	   }   
	   for(i=0;i<size-1;i++) {
	     MPI_Recv(max,r+1,MPI_INT,MPI_ANY_SOURCE,RESULT,MPI_COMM_WORLD,&status);
	     M[b++]=max;
	     MPI_Ssend(&t,0,MPI_INT,status.MPI_SOURCE,DONE,MPI_COMM_WORLD);
	   }
	   e=error_votacion_bagging(M,k,r+1,n_boos,m,j-(r+1));      
	   err+=e;			       
	 }
	 for(s=n%10;s<10;s++){
	   j=j+r;
	   b=0;
	   for(i=0;i<size-1;i++) {
	     MPI_Ssend(&t,0,MPI_INT,i+1,WORK,MPI_COMM_WORLD);
	   }
	   for(i=size-1;i<n_boos;i++)  {
	     MPI_Recv(max,r,MPI_INT,MPI_ANY_SOURCE,RESULT,MPI_COMM_WORLD,&status);
	     M[b++]= max ;
	     MPI_Ssend(&t,0,MPI_INT,status.MPI_SOURCE,WORK,MPI_COMM_WORLD);    
	   }   
	   for(i=0;i<size-1;i++) {
	     MPI_Recv(max,r,MPI_INT,MPI_ANY_SOURCE,RESULT,MPI_COMM_WORLD,&status);
	     M[b++]=max;
	     MPI_Ssend(&t,0,MPI_INT,status.MPI_SOURCE,DONE,MPI_COMM_WORLD);
	   }
	   e=error_votacion_bagging(M,k,r,n_boos,m,j-r);     
	   err+=e;				
	 }
       }
     }
     tiempo=MPI_Wtime()-tiempo;
     printf("\nPROGRMA %s DATA %s PROCRS  %d  N_BOOST %d ERRORES %f tiempo paralelo es %.3lf \n: ",argv[0],argv[1],size,n_boos,(double)err/(double)(n*promedio),(double)tiempo/(double)promedio);
     MPI_Finalize();      
   }
  }

  else{   /* SLAVE */
    int t,i,j,r,cont=0;
    int *indice=NULL;
    double *x;
    double **tes;
    double **X;
    double **trai;
    int *M ,parametro[5];
    int *k=NULL;
    MPI_Status status;   
    if(size==1){
      MPI_Finalize(); 
      return 0;
    }
    else{
      MPI_Bcast(parametro,5,MPI_INT,0,MPI_COMM_WORLD);
      x=calloc(parametro[0]*parametro[1],sizeof(double));      
      X=calloc(parametro[0],sizeof(double *));     
      tes=calloc(parametro[0],sizeof(double *));   
      trai=calloc(parametro[0],sizeof(double *));  
      k=calloc(parametro[0],sizeof(int));          
      indice=(int *)calloc(parametro[0],sizeof(int));
      MPI_Bcast(x,parametro[0]*parametro[1],MPI_DOUBLE,0,MPI_COMM_WORLD);
      for(t=0;t<parametro[4];t++){
	MPI_Bcast(indice,parametro[0],MPI_INT,0,MPI_COMM_WORLD);
	for(i=0;i<parametro[0];i++){
	  X[i]=x+indice[i]*parametro[1]; 
	  k[i]=X[i][parametro[1]-1];   
	}
	j=0;
	r=parametro[0]/10;
	if(parametro[0]%10==0){
	  for(i=0;i<10;i++){
	    j=j+r;
	    tes=test(X,j-r,r,parametro[1]);
	    cont=0;       
	    while(1) {
	      cont++;
	      MPI_Recv(&t,0,MPI_INT,0,MPI_ANY_TAG,MPI_COMM_WORLD,&status);
	      if(status.MPI_TAG==WORK) {   		
		trai=training(X,j-r,j,parametro[0],parametro[1],parametro[2]);    
		M=max_estimado_kernel_adaptativo(tes,trai,parametro[0],parametro[1],parametro[2],r);        
		MPI_Ssend(M,r,MPI_INT,0,RESULT,MPI_COMM_WORLD);
	      }
	      else
		break;
	    } 
	  }
	}
	else{
	  for(i=0;i<parametro[0]%10;i++){
	    j=j+r+1;
	    tes=test(X,j-(r+1),r+1,parametro[1]);
	    cont=0;
	    while(1) {
	      cont++;
	      MPI_Recv(&t,0,MPI_INT,0,MPI_ANY_TAG,MPI_COMM_WORLD,&status);
	      if(status.MPI_TAG==WORK) {   		
		printf("\nHOLA\n");
		trai=training(X,j-(r+1),j,parametro[0],parametro[1],parametro[2]);    
		M=max_estimado_kernel_adaptativo(tes,trai,parametro[0],parametro[1],parametro[2],r+1);        
		MPI_Ssend(M,r+1,MPI_INT,0,RESULT,MPI_COMM_WORLD);
	      }
	      else
		break;
	    } 
	  }
	  for(i=parametro[0]%10;i<10;i++){
	    j=j+r;
	    tes=test(X,j-r,r,parametro[1]);
	    cont=0;
	    while(1) {
	      cont++;
	      MPI_Recv(&t,0,MPI_INT,0,MPI_ANY_TAG,MPI_COMM_WORLD,&status);
	      if(status.MPI_TAG==WORK) {   		
		trai=training(X,j-r,j,parametro[0],parametro[1],parametro[2]);    
		M=max_estimado_kernel_adaptativo(tes,trai,parametro[0],parametro[1],parametro[2],r);        
		MPI_Ssend(M,r,MPI_INT,0,RESULT,MPI_COMM_WORLD);
	      }
	      else
		break;
	    } 
	  }
	} 
      }
      MPI_Finalize(); 
    }
    return 0;
  }
}
 /* Compile this program
 [elozano@penguin1 elozano]$ gcc -o  time_sys time_sys.c -lm

and run it as follows
[elozano@penguin1 elozano]$ time -p ./time_sys
*/









