#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include "mpi.h"
#define CTE  2.506631   /*CTE=sqrt(2.0*PI)*/


 double ** test(double **X,int min,int n,int p){
          double **temp;
          int i;
          temp=calloc(n,sizeof(double *));
          for(i=0;i<n;i++)
              temp[i]= X[i+min];         
          return temp;
          }

double ** training(double **X,int min,int max,int n,int p){
          double **temp;
          int i;
          temp=calloc(n,sizeof(double *));   
          for(i=0;i<min;i++)
                temp[i]= X[i];               
          for(i=min;i<n-(max-min);i++)
                temp[i]= X[i+max-min];      
           return temp;
         }

int * randperm(int n ){
       int i,j,min;
       int * a=NULL;
       int * indice=NULL;
       indice=(int *)calloc(n,sizeof(int)); 
       a=(int *)calloc(n,sizeof(int));      
       srand(time(NULL));                   
       for(i=0;i<n;i++)
           a[i]=rand()%n;                   
       for ( i = 0; i < n;i++ ){
           min=i;
           for (j = 0; j < n; j++ )
                if ( a[j] < a[min] ) {
                    min=j;
                }
           a[min]=n;
           indice[i]=min;                  
       }
       return indice;
       }

double kernel(double x){
       return 1.0/(exp((x*x)/2.0)*CTE);   /* CTE = sqrt(2.0*PI);*/
       }



double * banda(double **trai, int **clases,int n_trai,int j,int p){
       double s,d, Xmean;
       double *h=NULL;
       int i,v;
       h=calloc(p,sizeof(double));          

       for(v=0;v<p ;v++){
	 Xmean=0;
	 d=0;
	 s=0;
	 for(i=0;i<n_trai;i++){
	   s+=trai[clases[j][i]][v];
	 }
	 Xmean =s/n_trai;                   
	 for(i=0;i<n_trai;i++){
	   d+=(trai[clases[j][i]][v]-Xmean)*(trai[clases[j][i]][v]-Xmean);
	 }
	 d=sqrt(d/(n_trai-1));                          //para cada columna se calcula la desviacion estandar
	 
	 h[v]=d*(pow(4.0,1.0/(double)(p+4))/pow((double)((p+2)*n_trai),1.0/(double)(p+4)));
       }
       return h;
       }


double geometrica_par(double *f,int q,int n_trai){
     int i;
     double g=0.0;
     for(i=0;i<q;i++){
       g=g+log(f[i]);
     }
     g=exp(g/(double)n_trai);
     return g;
   }
 
double * fpiloto_par(double **trai,double *h,int **clases,double *g,int n_trai,int c,int p,int N,int rank,int size){
  MPI_Status status;
  int v,j,l=0,i,count,residuo=n_trai-size*(n_trai/size),q=n_trai/size;
  int inicial,final;
  double s=0.0,result,t,k,H=1.0,alpha=-0.5;
  double *f=NULL;
  double *fhat=NULL;
  double *temp=NULL;
  temp=calloc(q+1,sizeof(double));
  fhat=calloc(n_trai,sizeof(double));
  for(v=0;v<p;v++)
    H*=h[v];  
  H=H*(double)n_trai;
  f=calloc(q+1,sizeof(double));
  if(rank<residuo){
    inicial=rank*(q+1);
    final=(rank+1)*(q+1);
    q=q+1;
  }
  else{
    inicial=residuo+rank*q;
    final=residuo+(rank+1)*q;
  }
  for (i=inicial;i<final;i++){
    s=0.0;                   
    for(j=0;j<n_trai ;j++){
      k=1.0;
      for(v=0;v<p;v++){
	t=kernel((trai[clases[c][i]][v]-trai[clases[c][j]][v])/h[v]);
	k=k*t;
      }
      s=s+k;                        
    }
    f[i-inicial]=(s/H);  
  }       
  *g=geometrica_par(f,q,n_trai);
  MPI_Reduce(g,&result,1,MPI_DOUBLE,MPI_PROD,0,MPI_COMM_WORLD);
  *g=result;
  if(rank==0){
    if(rank<residuo)
      count=q+1;
    else
      count=q;
    for(j=0;j<count;j++){
      *(fhat+l)=*(f+j);
      l++;
    }
    for(i=0;i<size-1;i++){
      if(i+1<residuo)
	count=q+1;
      else
	count=q;
      MPI_Recv(temp,count,MPI_DOUBLE,i+1,0,MPI_COMM_WORLD,&status);
      for(j=0;j<count;j++){
	*(fhat+l)=*(temp+j);
	l++;
      }
    }
    for(i=0;i<n_trai;i++)
      fhat[i]= pow(fhat[i]/result,alpha);        
  }
  else{
    if(rank<residuo)
      MPI_Ssend(f,q+1,MPI_DOUBLE,0,0,MPI_COMM_WORLD);
    else
      MPI_Ssend(f,q,MPI_DOUBLE,0,0,MPI_COMM_WORLD);
  }
  MPI_Bcast(fhat,n_trai,MPI_DOUBLE,0,MPI_COMM_WORLD);
  return fhat;
}

double *par_kernel_adaptativo(double **x,double *h,double **trai,int **clases,int n_trai,int c,int n_cross, int p,int N,int rank, int size){
  int v,j,i,residuo=n_cross-size*(n_cross/size),q=n_cross/size;
  int inicial,final;
  double s=0.0,t,k,g,H=0.0;
  double *fhat=NULL;
  double *f=NULL;
  double pro=(double)n_trai/(double)(N-n_cross);
  fhat = calloc(n_trai,sizeof(double)); 
  for(v=0;v<p;v++)
    H+=log(h[v]);   
  H=exp(H)*(double)n_trai;
  fhat = fpiloto_par(trai,h,clases,&g,n_trai,c,p,N,rank,size);
  f=calloc(q+1,sizeof(double));
  if(rank<residuo){
    inicial=rank*(q+1);
    final=(rank+1)*(q+1);
  }
  else{
    inicial=residuo+rank*q;
    final=residuo+(rank+1)*q;
  }
  for (i=inicial;i<final;i++){
    s=0.0;                   
    for(j=0;j<n_trai ;j++){
      k=1.0;
      for(v=0;v<p;v++){
	t=kernel((x[i][v]-trai[clases[c][j]][v])/(fhat[j]*h[v]));
	k=k*t;
      }
      s=s+(k/pow(fhat[j],p-1));                       
    }      
    f[i-inicial]=pro*(s/H);
  }
  return f;
}


int par_estimado_kernel_adaptativo(double **x, double **X,int *k_indices,int n, int p,int m,int n_cross,int j_val,int rank,int size){
  
  int i,j,ntrai=n-n_cross,min=j_val-n_cross;
  int **clases;
  int *n_trai;
  int  error(double **,int *,int,int,int,int ,int);
  double e;
  double **f;
  double *h=NULL;
  
  n_trai=calloc(m+1,sizeof(int));
  clases =calloc(m+1,sizeof(int *));
  h=calloc(p,sizeof(double));
  f=calloc(m,sizeof(double *));
  for(j=0;j<=m;j++){
    n_trai[j]=0; 
    clases[j]=calloc(ntrai,sizeof(int));   
  }  
  for(i=0;i<ntrai;i++){
    clases[(int)X[i][p-1]][n_trai[(int)X[i][p-1]]++]=i;
  }
  for(j=0;j<m;j++){
    h=banda(X,clases,n_trai[j+1],j+1,p-1);                  
    f[j]=par_kernel_adaptativo(x,h,X,clases,n_trai[j+1],j+1,n_cross,p-1,n,rank,size);
  }
  e=error(f,k_indices,n_cross,m,min,rank,size);
  return e;
}

int error(double **f,int * k_indices ,int n_cross,int m,int min ,int rank,int size){
  int i,j,e=0,k,q=n_cross/size,residuo=n_cross-size*(n_cross/size),inicial;
  double max;
  if(rank<residuo){
    inicial=min+rank*(q+1);
    q=q+1;
  }
  else
    inicial=min+residuo+rank*q;
 
  for(j=0;j<q;j++){
    max=0;
    for(i=0;i<m;i++){
      if(f[i][j]>=max){
	max=f[i][j];
	k=i+1;
      }
    }            
    if(k_indices[j+inicial]!=k) 
      e++;
  }
  return e;
}

int main(int argc, char * argv[]){
  int rank,size;
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  
  if(rank==0){
    FILE *in;  
    int n,m,p,r;
    int par_e=0,err=0,e=0;
    int parametro[4];
    int i,j=0,promedio;
    int *k;
    int *indice;
    double time;
    double **X;
    double **f;
    double **trai;
    double **tes;
    double *x=NULL; 
    if(argc!=6){
      fprintf(stderr,"Uso de %s\n  nombre_del_archivo #_de_filas  #_de_columnas #_de_clases #_de_corridas_promedio\n",argv[0]);
      exit(1);
    }
    time=MPI_Wtime();
    n=atoi(argv[2]);            /*se convierte el segundo argumento a tipo entero*/
    p=atoi(argv[3]);            /*se convierte el tercer argumento a tipo entero*/
    m=atoi(argv[4]);            /*se convierte el cuarto argumento a tipo entero*/
    promedio = atoi(argv[5]);   /*se convierte el quinto argumento a tipo entero*/
    parametro[0]=n; 
    parametro[1]=p;
    parametro[2]=m;
    parametro[3]=promedio;
    MPI_Bcast(parametro,4,MPI_INT,0,MPI_COMM_WORLD);
    indice=calloc(n,sizeof(int));
    k=calloc(n,sizeof(int));
    x=calloc(n*p,sizeof(double));    
    tes=calloc(n,sizeof(double *)); 
    trai=calloc(n,sizeof(double *)); 
    f=calloc(m,sizeof(double *)); 
    X=calloc(n,sizeof(double *)); 
    in=fopen(argv[1],"r");        
    if(in==NULL){                
         printf("problemas con el archivo de salida");
         exit(1);
    }
    while (!feof(in)){   
             fscanf(in,"%lf",&x[j]);
             j++;
    }
    fclose(in);  
    
    MPI_Bcast(x,n*p,MPI_DOUBLE,0,MPI_COMM_WORLD);
    indice=randperm(n); 
    MPI_Bcast(indice,n,MPI_INT,0,MPI_COMM_WORLD);
    
    for(i=0;i<n;i++){
      X[i]=x+indice[i]*p; 
      k[i]=X[i][p-1];   
    }
    r=n/10;
    j=0;
    if(n%10==0){      
      for(i=0;i<10;i++){
	j=j+r;
	trai=training(X,j-r,j,n,p);  
	tes=test(X,j-r,r,p);         
	e=par_estimado_kernel_adaptativo(tes,trai,k,n,p,m,r,j,rank,size);  
	MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
	err+=par_e;                               
      }    
    }
    else {       
      for(i=0;i<n%10;i++){
	j=j+r+1;
	trai=training(X,j-r-1,j,n,p);     
	tes=test(X,j-r-1,r+1,p);           
	e=par_estimado_kernel_adaptativo(tes,trai,k,n,p,m,r+1,j,rank,size);  
	MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
	err+=par_e;                          
      }
      for(i=n%10;i<10;i++){
	j=j+r;
	trai=training(X,j-r,j,n,p);       
	tes=test(X,j-r,r,p);              
	e=par_estimado_kernel_adaptativo(tes,trai,k,n,p,m,r,j,rank,size);  
	MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
	err+=par_e;                             
      }
    }
    time=MPI_Wtime()-time;
    printf("\nPROGRAMA %s DATA %s PROCESADORES  %d   ERROR  %f  PAR_ERROR %d TIME %.3lf\n",argv[0],argv[1],size,(double)(err)/(double)(n*promedio),err,time);
    MPI_Finalize();
  }
  
  else{
    int i,j,r,e=0,par_e=0,err=0,temp[4];
    int par_cross(double *,int,int,int,int,int);
    int *indice;
    int *k;
    double *x=NULL;
    double *h;
    double **f;
    double **trai;
    double **training(double **,int,int,int,int);
    double **tes;
    double **test(double **,int,int,int);
    double **X;     
    MPI_Bcast(temp,4,MPI_INT,0,MPI_COMM_WORLD);
    indice=calloc(temp[0],sizeof(int));
    k=calloc(temp[0],sizeof(int));
    tes=calloc(temp[0],sizeof(double *)); 
    trai=calloc(temp[0],sizeof(double *)); 
    x=calloc(temp[0]*temp[1],sizeof(double));
    X=calloc(temp[0],sizeof(double *));
    f=calloc(temp[2],sizeof(double *));
    h=calloc(temp[1],sizeof(double));   
    MPI_Bcast(x,temp[0]*temp[1],MPI_DOUBLE,0,MPI_COMM_WORLD);
    MPI_Bcast(indice,temp[0],MPI_INT,0,MPI_COMM_WORLD);
    for(i=0;i<temp[0];i++){
      X[i]=x+indice[i]*temp[1]; 
      k[i]=X[i][temp[1]-1];   
    }
    r= temp[0]/10;
    j=0;
    if(temp[0]%10==0){      
      for(i=0;i<10;i++){
	j=j+r;
	trai=training(X,j-r,j,temp[0],temp[1]);  
	tes=test(X,j-r,r,temp[1]);         
	e=par_estimado_kernel_adaptativo(tes,trai,k,temp[0],temp[1],temp[2],r,j,rank,size);  
	MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
	err+=par_e;                               
      }
    }
    else {       
      for(i=0;i<temp[0]%10;i++){
	j=j+r+1;
	trai=training(X,j-r-1,j,temp[0],temp[1]);
	tes=test(X,j-r-1,r+1,temp[1]);           
	e=par_estimado_kernel_adaptativo(tes,trai,k,temp[0],temp[1],temp[2],r+1,j,rank,size);
	MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
	err+=par_e;                          
      }
      for(i=temp[0]%10;i<10;i++){
	j=j+r;
	trai=training(X,j-r,j,temp[0],temp[1]);
	tes=test(X,j-r,r,temp[1]);              
	e=par_estimado_kernel_adaptativo(tes,trai,k,temp[0],temp[1],temp[2],r,j,rank,size);  
	MPI_Reduce(&e,&par_e,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD);
	err+=par_e;                             
      }
    }
    MPI_Finalize();
  }
  return 0;
}














