/* Programa BAGGING que calcula el porcentaje de error, dicho programa saca muestras con    *
 *reemplazamiento para obetener los estimados  y luego clasificar para obtener los errores  */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#define CTE 2.506631   //CTE=sqrt(2.0*PI)
#define MAX 50
#define PI 3.1416

 
/*funcion que dado una matriz X, obtiene la n-esima division de X,  se debe ingresar un entero *
 * minimo, el # de filas de la division, y el # de columnas de la matriz                       */

 double ** test(double **X,int min,int n,int p){
          double **temp;
          int i;
          temp=calloc(n,sizeof(double *));    //se asigna memoria dinamica para la matriz de salida
          for(i=0;i<n;i++)
              temp[i]= X[i+min];   //se asigna al vector de salida las filas correspondientes  de  X
          return temp;
          }

/*funcion que dado una matriz X, obtiene una muestra con reemplazamiento de las filas de X distintas de *
 * de las filas  que se uso para test, se debe ingresar un entero  minimo, maximo, # de filas de la     *
 * division  y el # de columnas de la matriz                       				        */

double ** training(double **X,int min,int max,int n,int p){
          double **temp;
          int i;
          temp=calloc(n,sizeof(double *));   //se asigna memoria dinamica para la matriz de salida
          for(i=0;i<min;i++)
                temp[i]= X[rand()%min];    //se asigna al vector de salida las filas aleatoriamente desede 0 hasta un minimo
          for(i=min;i<n-(max-min);i++)
                temp[i]= X[rand()%(n-max)+max]; //se asigna al vector de salida las filas aleatoriamente desede un maximo hasta
           return temp;				//el # total de filas de la matriz X
         }

/*funcion que genera numeros aleatorios desde cero hasta n*/

int * randperm(int n ){
       int i,j,min;
       int * a=NULL;
       int * indice=NULL;
       indice=(int *)calloc(n,sizeof(int));  //se asigna memoria dinamica para el vector de salida
       a=(int *)calloc(n,sizeof(int));       //se asigna memoria dinamica para el vector temporal de #s aleatorios
       srand(time(NULL));       //generador de los #s aleatorios utilizando el tiempo como semilla
       for(i=0;i<n;i++)
           a[i]=rand()%n;        //se almacena #s aleatorios de 0 hasta n
       for ( i = 0; i < n;i++ ){
           min=i;
           for (j = 0; j < n; j++ )
                if ( a[j] < a[min] ) {
                    min=j;
                }
           a[min]=n;
           indice[i]=min;   //se almacena en el vector de salida los indices de los #s aleatorios de menor a mayor
       }
       return indice;
       }

/*funcion que calcula el kernel gaussiano*/
double kernel(double x){
       return 1.0/((exp((x*x)/2.0))*CTE);        //CTE =sqrt(2.0*PI)
       }

/*funcion que calcula el vector  del ancho de banda para una clase X, se debe ingresar el # de filas de la clase asi como  el # de columanas*/

double * banda(double **X, int n,int p){
       double s,d, Xmean,*h=NULL;
       int i,v;

       h=calloc(n,sizeof(double));    //se asigna memoria dinamica para el vector de salida
       for(v=0;v<p ;v++){
            Xmean=0;
            d=0;
            s=0;
            for(i=0;i<n;i++){
                 s+=X[i][v];
            }
            Xmean =s/n;        //para cada columna se calcula la media por filas
            for(i=0;i<n;i++){
                d+=(X[i][v]-Xmean)*(X[i][v]-Xmean);
            }
            d=sqrt(d/(n-1));     //para cada columna se calcula la desviacion estandar
                                 //se almacena el valor correspondiente al vector de salida
            h[v]=d*(pow(4.0,1.0/(double)(p+4))/pow((double)((p+2)*n),1.0/(double)(p+4)));

       }
       return h;
       }

/*funcion que calcula la suma de la productoria de los kernel dado una clase X y un test x, se debe ingresar el vector del *
 *ancho de banda, la iesima fila del test(i), el # de columnas(p) y el # de filas de la clase(m)                           */

 double suma_productoria(double **x,double *h, double **X,int i, int p,int m ){
        double s=0.0,k,t=0.0;
        int j,v;
        for(j=0;j<m ;j++){
                k=1.0;
                for(v=0;v<p;v++){
                     t=kernel((x[i][v]-X[j][v])/h[v]);  // para cada fila de la clase X se calcula la productoria de los kernels por columnas
                     k=k*t;
                }
              s=s+k;  //para acumular las productorias y asi obtener la sumatoria.
        }
        return s;
        }

 /*funcion que calcula el estimado del test x dado una clase X , se debe ingresar el vector del ancho de banda (h), el # de filas del test(n),*
  *el # de columnas(p), el # de filas para una clase del training(m)  y el numero de filas de la matriz original(N)                           */

 double * estimado(double **x,double *h,double **X,int n, int p,int m,int N){
       int v,i;
       double s=0.0,H=1.0;
       double *f=NULL;
       double pro=(double)m/(double)(N-n);  //se calcula la proporcion para el estimado de una clase cualquiera

       f=calloc(n,sizeof(double));        //se asigna memoria dinamica para el vector de salida
       for(v=0;v<p;v++)
                   H=H*h[v];             //se calcula la productoria de los elemantos del ancho de  banda
       H=H*(double)m;
       for (i=0;i<n;i++){
              s=suma_productoria(x,h,X,i,p,m);
              f[i]=pro*(s/H);            //se almacena los estimados para cada fila del test
       }
       return f;
       }
/* funcion que calcula los errores dado una matriz M de dimension(n_boos X n_test), se debe ingresar el vector de indices de la muestra original(k)  *
 * el # de columnas de M(n_test), el # de filas de M(n_boos), el # de clases(m) y un entero minimo(min) para relizar las comparaciones con el vector k */

 int error(int **M,int * k_indices ,int n_test,int n_boos,int m,int min ){
       int i,j,e=0,k,max;
       int *clase=NULL;
       clase=calloc(m+1,sizeof(int));  //se asigna memoria dinamica para acunular la cantidad de veces que aparece en cada clase
       for(j=0;j<n_test;j++){
             for(i=0;i<m+1;i++) clase[i]=0;   //se inicializa el contador de cada clase a cero
             for(i=0;i<n_boos;i++) clase[M[i][j]]++; //para cada clase que se halla en la i-esima fila se aumenta el contador
             max=0;
             k=0;
             for(i=0;i<m+1;i++){
                 if(clase[i]>max){       //se calcula la clase que mas aparece en cada columna 
                      max=clase[i];
                      k=i;      
                 }
                      
             }
             if(k_indices[j+min]!=k)     //se verifica si los indices coenciden o no con la clase que mas aparece para aumentar el error
                 e++;
       }
       return e;
       }

/*funcion que calcula el vector de maximos dado una matriz f de estimados, se debe ingresar el # de filas de f (m), el # de columnas(n)*/
int  * maximos(double **f,int n,int m ){
      int i,j,k;
      int *max=NULL;
      double maximo;
      max = calloc(n,sizeof(int));    //se asigna memoria dinamica para el vector de salida
      for(j=0;j<n;j++){
             maximo=0;
             for(i=0;i<m;i++){
                   if(f[i][j]>=maximo){
                        maximo=f[i][j];
                        k=i+1;
                    }
             }
             max[j]=k;      //se almacena los indices del estimado mas grande
       }
       return max;
       }

/* funcion que sirve para imprimir matrices de tipo double en la pantalla, se ingresar la matriz con sus respectivas filas y columnas*/
void print(double **X,int n,int m){
       int i,j;
        for(i=0;i<n;i++){
                for(j=0;j<m;j++)
                      printf("%e\t",X[i][j]);
                 printf("\n");
           }

       }
       
/* funcion que sirve para imprimir matrices de tipo entero  en la pantalla, se ingresar la matriz con sus respectivas filas y columnas*/
void print2(int  **X,int n,int m){
       int i,j;
        for(i=0;i<n;i++){
                for(j=0;j<m;j++)
                      printf("%d\t",X[i][j]);
                 printf("\n");
           }

       }

/*funcion que calcula la matriz de estimados, se le debe ingresar la matriz test(x), matriz training(X) , # de filas del training(n),  *
 * # de columnas(p), # de clases(m), # de filas del test(r), y el # de filas de la matriz original (N)                                 */

double **estimated(double ** x, double ** X,int n, int p,int m,int r,int N){
       double **f;
       double ** temp;
       double *h=NULL;
       int i,j,cont;

       f=calloc(m,sizeof(double *));      //se asigna memoria dinamica para la matriz de estimados
       temp=calloc(n,sizeof(double *));  //se asigna memoria dinamica para la matriz de clases
       h=calloc(p,sizeof(double));       //se asigna memoria dinamica para el vector del ancho de banda
       for(j=0;j<m;j++){
            cont=0;
            for(i=0;i<n;i++)
                    if(X[i][p-1]==(double)(j+1)){
                       temp[cont++]= X[i];	//se almacena en temp las filas de la matriz training correspondientes a la clase j
                    }

            h=banda(temp,cont,p-1);          //se calcula el vector del ancho de banda para una clase dada
            f[j] = estimado(x,h,temp,r,p-1,cont,N);     //para cada clase j se almacena en la matriz f los estimados para una clase dada

      }
      return f;
}

/*funcion que calcula los errore al clasificar, se debe ingresar el vector de los datos originales(x), el numero de filas(n), el numero de *
 * muestras boostrapeadas (n_boos), el # de clases(m) y el # de columnas (p)								   */

int boostrap(double *x,int n,int n_boos,int m,int p){
    int i,j,r=n/10,e=0,err=0,b;
    int *indice=NULL;
    double **f;
    double **tes;
    double **X;
    double **trai;
    int **M;
    int *k=NULL;
    M=calloc(n_boos,sizeof(int *));    //se asigna memoria dinamica para la matriz de maximos
    X=calloc(n,sizeof(double *));      //se asigna memoria dinamica para la matriz original
    tes=calloc(n,sizeof(double *));    //se asigna memoria dinamica para la matriz de test
    trai=calloc(n,sizeof(double *));   //se asigna memoria dinamica para la matriz de training
    k=calloc(n,sizeof(int));           //se asigna memoria dinamica para el vector de indices
    indice=(int *)calloc(n,sizeof(int)); //se asigna memoria dinamica para el vector de indices permutados

    indice=randperm(n);  //se llama a la funcion randperm para para obtener los indices permutados
    for(i=0;i<n;i++){
          X[i]=x+indice[i]*p;   //se hace una copia del vector x a la matriz X
          k[i]=X[i][p-1];        // se almacena los valores de la ultima columna de X

    }
    j=0;
    if(n%10==0){		//en el caso en que el # de filas sea divisible por 10
          for(i=0;i<10;i++){
             j=j+r;
             tes=test(X,j-r,r,p);     //se llama a la funcion test para obtener la matriz tes
             for(b=0;b<n_boos;b++){
                  trai=training(X,j-r,j,n,p);     //para cada test se obtiene la matriz training
                  f=estimated(tes,trai,n-r,p,m,r,n);  //se calcula la matriz de estimados
                  M[b]=maximos(f,r,m);           //se calcula la matriz de maximos
             }
             e=error(M,k,r,n_boos,m,j-r);       //se llama a la funcion error para obtener los errores
             err+=e;				//se acunula los errores
          }
     }
     else {			//en el caso en que el # de filas no sea divisible  por 10
           for(i=0;i<n%10;i++){
              j=j+r+1;
              tes=test(X,j-r-1,r+1,p);                  //se llama a la funcion test para obtener la matriz tes
              for(b=0;b<n_boos;b++){
                  trai=training(X,j-r-1,j,n,p);         //para cada test se obtiene la matriz training
                  f=estimated(tes,trai,n-(r+1),p,m,r+1,n);   //se calcula la matriz de estimados
                  M[b]=maximos(f,r+1,m);                //se calcula la matriz de maximos
             }
             e=error(M,k,r+1,n_boos,m,j-(r+1));         //se llama a la funcion error para obtener los errores
             err+=e;                                    //se acunula los errores

           }
           for(i=n%10;i<10;i++){
               j=j+r;
               tes=test(X,j-r,r,p);                //se llama a la funcion test para obtener la matriz tes
               for(b=0;b<n_boos;b++){
                  trai=training(X,j-r,j,n,p);       //para cada test se obtiene la matriz training
                  f=estimated(tes,trai,n-r,p,m,r,n);     //se calcula la matriz de estimados
                  M[b]=maximos(f,r,m);                //se calcula la matriz de maximos
               }
               e=error(M,k,r,n_boos,m,j-r);        //se llama a la funcion error para obtener los errores
               err+=e;				   //se acunula los errores
           }
     }
     return err;
     }

/* funcion main, se debe ingresar en la linea de comandos lo siguiente:  *
 * argv [1] la matriz original; argv [2] el numero de filas, argv [3]   *
 * argv [3] el numero de columnas; argv [4] el numero de clases y      *
 * argv [5] el numero de muestras boostrapeadas                       */

int main(int argc, char * argv[]){

    FILE *in;               //se declara un apuntador de tipo FILE
    int j=0,n_boos;
    double *x=NULL;         //se declara apuntador de tipo double para leer los datos del archivo
    int n,m,p;
    int err=0;
    long int passed;
    clock_t  now, later;      //se define dos variables te tipo clock_t para calcular el tiempo


    srand(time(0x0));      //la funcion srand genera numeros aleatorios con semilla respecto al tiempo

    now = clock();        //se toma el tiempo al inicio del programa.
    printf("TIEMPO INICIAL %lu \n",now);
    n=atoi(argv[2]);     //se convierte el segundo argumento a tipo entero
    p=atoi(argv[3]);     //se convierte el tercer argumento a tipo entero
    m=atoi(argv[4]);     //se convierte el cuarto argumento a tipo entero
    n_boos=atoi(argv[5]);    //se convierte el quinto argumento a tipo entero
    x=calloc(n*p,sizeof(double));  //se asiga memoria dinamicamente para el vector donde se va leer
    
    in=fopen(argv[1],"r");        //se abre el archivo del primer argumento solo para lectura
    if(in==NULL){                 //si no se pudo abrir entonces se da un mensaje de error y el programa finaliza
         printf("problemas con el archivo de salida");
         exit(1);
    }

    while (!feof(in)){       //mientras no se acabe los elementos del archivo se seguira leendo
             fscanf(in,"%lf",&x[j]);   //se copia en el vector x los elementos del archivo
             j++;
      }

   fclose(in);           //se cierra el archivo de lectura
   err= boostrap(x, n, n_boos, m, p);//se llama a la funcion boostrap para obtener los errores de clasificacion
   printf("\nERRORES  %d \n",err);
   printf("\nPORCENTAJE DE ERRORES  %f \n",(double)err/(double)n);
   later=clock();                    //se toma el tiempo final
   printf("TIEMPO FINAL %lu \n",later);
   passed=later-now;                 //se calcula la diferencia de tiempos para obtener el tiempo real de corrida
   printf("\n\nEL TIEMPO  ES %lu \n\n",passed);
   return 0;
 }
